String.prototype.endsWith = function(suffix) {
  return this.indexOf(suffix, this.length - suffix.length) !== -1;
};

var heighLevel = 9, api_level = "api_level";
var address = window.location.href.toString().split(window.location.host)[1];// get the current page url
var htmlFolderPath = "", htmlString = "", slesh = '/', domain = "https://".concat(document.domain);

if (address == 'i') { // in offline state
  address = document.location.pathname;
  htmlString = ".html";
  htmlFolderPath = address.substring(0, address.indexOf("UserGuide/") + "UserGuide".length);
  domain = "file://";
  slesh = '';
}

var path = window.location.pathname;
var page = path.split('/').pop();
var pageBase = '';
var pageVariation = '';

if (page.endsWith('.html')) {
  var result = page.split('.html');
  if (result && result[0]) {
    pageVariation = result[0];
  }
}
else {
  pageVariation = page + '.html';
}

var pattern = /(.*)level([1-9]+)(\.html)?/i;
var level = 9;

if (pattern.test(page) === true) {
  var matches = pattern.exec(page);
  if (matches[2] && !isNaN(matches[2])) {
    level = parseInt(matches[2], 10);
  }
  if (matches[1]) {
    pageBase = matches[1];
  }
}

(function($) {
  
  Drupal.behaviors.page = {
    attach: function() {

      $('.showAll').click(function(){  // toggle
        $('.' .concat($(this).attr('toggle'))).toggle('slow'); // Toggles visibility.
      });
      
      var first = 1;

      $('#sidebar-first .active-trail a').each(function() { // set specific class to the title of each tree
        if(first == 1) {
          $(this).addClass('book_title');
          first = 0;
        } else {
          return;
        }
      });
      
      $(document).ready(function() {
        $('.apiLevelSelector option[value=' + level + ']').attr('selected', 'selected');
        $('a[href$="level' + level + '"], a[href$="level' + level + '.html"]', '#sidebar-first .active-trail').addClass('current_api');
      });

    }
  };
  
  Drupal.behaviors.main_menu = {
    attach: function() {
      $(document).ready(function() {
        if (address.match('/introduction')) {
          $('#page').addClass('introduction');
        } else if (address.match('/home') || address == '/' || address.match('index.html')) {
          $('#page').addClass('Home');
        } else if (address.match('/sdk')) {
          $('#page').addClass('sdk');
        } else if (address.match('/faq')) {
          $('#page').addClass('faq');
        } else if (address.match('/technology')) {
          // technology home page
          if (address.match('/technology/')) {
            $('#page').addClass('technology');
          } else if (address == htmlFolderPath.concat('/technology', htmlString)) {
            $('#page').addClass('technology technology-home');
          }

          //technology sub pages
          if (address.match('/technology/basics')) {
            if (address.match('/basics/')) {
              $('#page').addClass('basics');
            } else if (address == htmlFolderPath.concat('/technology/basics', htmlString)) {
              $('#page').addClass('basics basics-home');
            }
          } else if (address.match('/technology/dal-environment')) {
            $('#page').addClass('dal-environment');
          } else if (address.match('/technology/guidelines')) {
            $('#page').addClass('guidelines');
          } else if (address.match('/technology/api-reference') || address.match('/develop/references')) {
            $('#page').addClass('Reference');

            if (address.match('/technology/api-reference/host-interface-apis/host-interface-android/') || address.match('/develop/references/host-interface-apis/host-interface-android/')) {
              $('#page').addClass('android');
            }
            if (address.match('/technology/api-reference/host-interface-apis/host-interface-android') || address.match('/develop/references/host-interface-apis/host-interface-android')) {
              $('#page').addClass('android android-home');
            }
            if (address.match('/technology/api-reference/host-interface-apis') || address.match('/develop/references/host-interface-apis')) {
              $('#page').addClass('JHI');
            }
            if (address.match('/technology/api-reference/ta-apis/') || address.match('/technology/api-reference/applet-apis/') || address.match('/develop/references/ta-apis/')) {
              $('#page').addClass('TA');
            }
            if (address.match('/technology/api-reference/ta-apis') || address.match('/technology/api-reference/applet-apis') || address.match('/develop/references/ta-apis')) {
              $('#page').addClass('TA TA-home');
            }
            if (address.match('/technology/api-reference/jhi-apis')) {
              $('#page').addClass('JHI');
            }
          }

          if (address.match('/sdk/download')) {
            $('#page').addClass('Download');
          }
        }
      });
    }
  };

  Drupal.behaviors.apiLevel = {
    attach: function() {

      $('.apiLevelSelector').change(function(e) {
        e.preventDefault();
        if (!isNaN($(e.target).find(':selected').val())) {
          var _level = parseInt($(e.target).find(':selected').val(), 10);
          page = pageBase + 'level' + _level;
          var _page = $('ul.menu li > a[href="' + page + '"]');
          if ($(_page).length === 0) {
            _page = $('ul.menu li > a[href="' + page + '.html"]');
          }
          if ($(_page).length === 1) {
            window.location.href = $(_page).attr('href');
          }
          else { // find the most appropriate level API available based on the selected API level and current API level.

            if (_level > level) { // customer is increasing their API level. since it wasn't found, the API is deprecated
              for (var i = _level; i > 0; i--) {
                page = pageBase + 'level' + i;
                _page = $('ul.menu li > a[href="' + page + '"]');
                if ($(_page).length === 0) {
                  _page = $('ul.menu li > a[href="' + page + '.html"]');
                }                
                if ($(_page).length === 1) {
                  if (confirm('This API is deprecated in level: ' + _level + '. It is available only until level: ' + i + '.\nClick OK to be redirected to that page.') === true) {
                    window.location.href = $(_page).attr('href');
                  }
                  else {
                    $('.apiLevelSelector').val(level);
                  }
                  break;
                }
              }
            } 
            else { // customer is decreasing their API level. since it wasn't found, the API isn't available
              for (var i = _level; i < 10; i++) {
                page = pageBase + 'level' + i;
                _page = $('ul.menu li > a[href="' + page + '"]');
                if ($(_page).length === 0) {
                  _page = $('ul.menu li > a[href="' + page + '.html"]');
                }
                if ($(_page).length === 1) {
                  if (confirm('This API is only available starting from level: ' + i + '.\nClick OK to be redirected to that page.') === true) {
                    window.location.href = $(_page).attr('href');                   
                  }
                  else {
                    $('.apiLevelSelector').val(level);
                  }
                  break;
                }
              }
            }
          }
        } 
      });

    }
  };

})(jQuery);
