/**
 * sasson javascript core
 *
 */
(function($) {

  Drupal.sasson = {};

  /**
   * This script will watch files for changes and
   * automatically refresh the browser when a file is modified.
   */
  Drupal.sasson.watch = function(url, instant) {
    
    var request;
    var dateModified;

    // Check the last time the file was modified
    request = $.ajax({
      type: "HEAD",
      url: url,
      success: function () {
        dateModified = request.getResponseHeader("Last-Modified");
        interval = setInterval(check,1000);
      }
    });

    var updateStyle = function(filename) {
      var headElm = $("head > *:contains('" + filename + ".css')");
      headElm.html(headElm.html().replace(filename + '.css?', filename + '.css?s'));
      dateModified = request.getResponseHeader("Last-Modified");
    };

    // Check every second if the timestamp was modified
    var check = function() {
      request = $.ajax({
        type: "HEAD",
        url: url,
        success: function () {
          if (dateModified != request.getResponseHeader("Last-Modified")) {
            var filename = url.split('/');
            filename = filename[filename.length - 1].split('.');
            var fileExt = filename[1];
            filename = filename[0];
            if (instant && fileExt == 'css') {
              // css file - update head
              updateStyle(filename);
            } else if (instant && (fileExt == 'scss' || fileExt == 'sass')) {
              // SASS/SCSS file - trigger sass compilation with an ajax call and update head
              $.ajax({
                url: "",
                success: function () {
                  updateStyle(filename);
                }
              });
            } else {
              // Reload the page
              location.reload();
            }
          }
        }
      });
    };
  };
  
  Drupal.behaviors.sasson = {
    attach: function(context) {

      $('html').removeClass('no-js');

    }
  };

  Drupal.behaviors.showOverlay = {
    attach: function(context) {

      $('body.show-overlay').each(function() {
        var body = $(this);
        var overlay = $('<div id="overlay"><img src="'+ Drupal.settings.sasson['overlay_url'] +'"/></div>');
        var overlayToggle = $('<div class="toggle-overlay" ><div>' + Drupal.t('Overlay') + '</div></div>');
        body.append(overlay);
        body.append(overlayToggle);
        $("#overlay").css({ opacity: Drupal.settings.sasson['overlay_opacity'] });
        $('.toggle-overlay').click(function() {
          $('body').toggleClass('show-overlay');
          $('#overlay').toggle();
          $(this).toggleClass("off");
        });
        $("#overlay").draggable();
      });

    }
  };

  Drupal.behaviors.showGrid = {
    attach: function(context) {

      $('body.show-grid').each(function() {
        var body = $(this);
        var gridToggle = $('<div class="toggle-grid" ><div>' + Drupal.t('Grid') + '</div></div>');
        body.append(gridToggle);
        $('.toggle-grid').click(function() {
          $('body').toggleClass('show-grid');
          $(this).toggleClass("off");
        });
      });

    }
  };

})(jQuery);


// Console.log wrapper to avoid errors when firebug is not present
// usage: log('inside coolFunc',this,arguments);
// paulirish.com/2009/log-a-lightweight-wrapper-for-consolelog/
window.log = function() {
  log.history = log.history || [];   // store logs to an array for reference
  log.history.push(arguments);
  if (this.console) {
    console.log(Array.prototype.slice.call(arguments));
  }
};
;
/*
 * aditional functions
 */
var heighLevel = 9, isLoad = 0, api_level = "api_level";
var address = window.location.href.toString().split(window.location.host)[1];// get the current page url
var htmlFolderPath = "", htmlString = "", slesh = '/', domain = "http://".concat(document.domain);

if(address == 'i') { // in offline state
  address = document.location.pathname;
  htmlString = ".html";
  htmlFolderPath = address.substring(0, address.indexOf("UsersGuide/") + "UsersGuide".length);
  domain = "file://";
  slesh = '';
}

(function($) {
  
  Drupal.behaviors.page = {
    attach: function() {
      $('.showAll').click(function(){  // toggle
        $('.' .concat($(this).attr('toggle'))).toggle('slow'); // Toggles visibility.
      });
      
      var first = 1;
      $('#sidebar-first .active-trail a').each(function() { // set specific class to the title of each tree
        if(first == 1) {
          $(this).addClass('book_title');
          first = 0;
        } else {
          return;
        }
      });
      
      $(document).ready(function() {
        $('#block-system-powered-by').find('.content').children().html('<span class=powered_by_intel>Copyright &#169; 2018, Intel Corporation. All rights reserved.&nbsp;&nbsp;&nbsp;&nbsp;|&nbsp;&nbsp;<a id="legal" href="https://software.intel.com/sites/landingpage/dal/Legal">Legal</a>&nbsp;&nbsp;|&nbsp;&nbsp;<a href="https://software.intel.com/sites/landingpage/dal/contact" id="Support">Support</a>&nbsp;&nbsp;|&nbsp;&nbsp;<a href="https://software.intel.com/sites/landingpage/dal/sdk/download" id="Download">Download</a>&nbsp;&nbsp;|&nbsp;&nbsp;<a href="https://software.intel.com/sites/landingpage/dal/contact" id="ContactUs">Contact us</a>&nbsp;&nbsp;|&nbsp;&nbsp;<a href="https://software.intel.com/sites/landingpage/dal/https://software.intel.com/sites/landingpage/dal/faq" id="FAQ">FAQ</a>&nbsp;&nbsp;<p>Intel Confidential</p></span>'); // poweredby
        isLoad = 1; // for the apiLevel function
      });
    }
  };
  
  Drupal.behaviors.siteMap = {
    attach: function(){ 
      $('#siteMap').click(function() { // show / hide the site map
        if($("#block-sitemap-block-sitemap-block").hasClass('show')) {
          $("#block-sitemap-block-sitemap-block").removeClass('show');
          $("#block-sitemap-block-sitemap-block").addClass('hide');
        } else {
          $("#block-sitemap-block-sitemap-block").addClass('show');
          $("html, body").animate({ scrollTop: $(document).height() }, 2000);
          $("#block-sitemap-block-sitemap-block").removeClass('hide');
        }
      });
      $(document).ready(function() {
        if(address == htmlFolderPath.concat('/Full_sitemap', htmlString)) {
          $('#block-full-sitemap-full-sitemap li a').each(function() { // show only the highest API level references tab (in the site map);
            if(($(this).attr('href').match(slesh.concat("develop/references")) && $(this).attr('href').match(api_level.concat(heighLevel))) || $(this).attr('href') == slesh.concat("develop/references", htmlString) || $(this).attr('href') == "../".concat("develop/references", htmlString)) {
              $(this).addClass('displayAPI')
            } else {
              $(this).removeClass("displayAPI");
            }
          });
        } else {
          $('#block-sitemap-block-sitemap-block li a').each(function() { // show only the highest API level references tab (in the site map);
            if($(this).attr('href') == address.concat(htmlString) || this.href == domain.concat(address)) {
              $(this).addClass("active");
            }
	    if(($(this).attr('href').match(slesh.concat("references")) && $(this).attr('href').match(api_level.concat(heighLevel))) || $(this).attr('href') == "/develop/references" || $(this).attr('href').match("references.html")) {
	      $(this).addClass('displayAPI')
	    } else {
	      $(this).removeClass("displayAPI");
	    }
          });
        }
      });
    }
  };
  
  Drupal.behaviors.main_menu = {
	attach: function(){ 
		$(document).ready(function() {
			if(address.match('/introduction')) {
				$('#page').addClass('introduction');
			} else if(address.match('/home') || address == '/' || address.match('index.html')) {
				$('#page').addClass('Home');
			} else if(address.match('/sdk')) {
				$('#page').addClass('sdk');
			} else if(address.match('/faq')) {
				$('#page').addClass('faq');
			} else if(address.match('/technology')) {
				// technology home page
				if(address.match('/technology/')) {
					$('#page').addClass('technology');
				} else if(address == htmlFolderPath.concat('/technology', htmlString)) {
					$('#page').addClass('technology technology-home');
				}
				
				//technology sub pages
				if(address.match('/technology/basics')) {
					if(address.match('/basics/')) {
						$('#page').addClass('basics');
					} else if(address == htmlFolderPath.concat('/technology/basics', htmlString)) {
						$('#page').addClass('basics basics-home');
					}
				} else if(address.match('/technology/dal-environment')) {
					$('#page').addClass('dal-environment');
				} else if(address.match('/technology/guidelines')) {
					$('#page').addClass('guidelines');
				} else if(address.match('/technology/api-reference') || address.match('/develop/references')) {
				    $('#page').addClass('Reference');
					
					if(address.match('/technology/api-reference/host-interface-apis/host-interface-android/') || address.match('/develop/references/host-interface-apis/host-interface-android/')){
						$('#page').addClass('android');
					}
					if (address.match('/technology/api-reference/host-interface-apis/host-interface-android') || address.match('/develop/references/host-interface-apis/host-interface-android')) {
					    $('#page').addClass('android android-home');
					}
					if (address.match('/technology/api-reference/host-interface-apis') || address.match('/develop/references/host-interface-apis')) {
				        $('#page').addClass('JHI');
					}
					if(address.match('/technology/api-reference/ta-apis/') || address.match('/technology/api-reference/applet-apis/') || address.match('/develop/references/ta-apis/')) {
						$('#page').addClass('TA');
					}
					if (address.match('/technology/api-reference/ta-apis') || address.match('/technology/api-reference/applet-apis') || address.match('/develop/references/ta-apis')) {
					    $('#page').addClass('TA TA-home');
					}
					if (address.match('/technology/api-reference/jhi-apis')) {
				        $('#page').addClass('JHI');
				    } 
				}
				
				if(address.match('/sdk/download')) {
					$('#page').addClass('Download');
				}
			}
		}); 
	}
  };
  
  Drupal.behaviors.search = {
    attach: function() {
      
      $("#edit-search-block-form--2").focus(function() {
        $(".container-inline").addClass('active');
      });
      
      $(".container-inline").mouseover(function() {
        $(".container-inline").addClass('active');
        $("#edit-search-block-form--2").focus();
      });
      
      $(".container-inline").mouseout(function() {
        if ($("#edit-search-block-form--2").is(":focus")) {
          return;
        }
        if ($("#edit-search-block-form--2").val() == '') {
          setTimeout(function() {
            $(".container-inline").removeClass('active');
            $("#edit-search-block-form--2").blur();
          }, 250);
        }
      });
      
      $("#edit-search-block-form--2").blur(function() {
        if ($("#edit-search-block-form--2").val() == '') {
          $(".container-inline").removeClass('active');
        }
      });
      
      $(document).ready(function() { // search in offline state
        if(htmlString.length != 0) {
	  $('#search-block-form').attr('action', "/".concat(htmlFolderPath.substring(htmlFolderPath.indexOf(":/") + 2, htmlFolderPath.length), '/search.html'));
	  $('#search-block-form').attr('method', 'get');
	  $('#edit-search-block-form--2').attr('name', 'zoom_query');
	  $('#edit-submit').attr('value', 'Submit');
	}
      });
    }
  };
  
  Drupal.behaviors.apiLevel = {
    attach: function() {
      $(".apiLevelSelector").change(function () {
        var level, newHref = "", isCurrentApi, newLevel = heighLevel + 1, foundPage = 2, currHref, index, a;
        
        if(address.match('/technology/api-reference/ta-apis') || address.match('/develop/references/ta-apis') || address.match('/technology/api-reference/applet-apis')) { // we are in the references tab
          if(isLoad == 1) { // the event was activated because that there was reload page.
            level = address.substring(address.indexOf(api_level) + 9, address.indexOf(api_level) + 10); // save the current API level
            if(level == '/' || level == '0' || level == 'o') { // ta-apis tab
              level = heighLevel; // set the heigh level
            }
          } else {
            $(".apiLevelSelector option:selected").each(function () {
              level = $(this).attr('title'); // save the new level that selected
            });
          }
          $('#sidebar-first .active-trail a').each(function() { // run over all the book tree
	    if(htmlString.length == 0) {
	      currHref = $(this).attr('href');
	      index = currHref.indexOf(api_level) + 9;
	    } else { // offline state
	      currHref = this.href.substring((this.href).indexOf(domain) + 7, (this.href).length);
	      index = currHref.indexOf(api_level) + 9;
	    }
            
            if((index != 8 && (currHref.substring(index, index + 1) == level))) { // the current book link match to the current level  
              $(this).addClass('current_api');
              isCurrentApi = 1;
            } else {
              $(this).removeClass('current_api');
              isCurrentApi = 0;
            }
            
            if(index != 8 && isLoad != 1) {
              if(currHref != address) { // Check if the requested page desired APIlevel - is not the current page. And finding it.
                if(isCurrentApi == 1) {
                  if(currHref.substring(0, index).concat(htmlString) == address.substring(0, address.indexOf(api_level) + 9).concat(htmlString) && currHref.substring(currHref.indexOf(api_level) + 9, currHref.indexOf(api_level) + 10) == level){ // We found the page that fits the desired level.
                    newHref = domain.concat(currHref);
                    foundPage = 1;
                    newLevel = level;
                    window.location = newHref;
                    return;
                  }
                }
              }
              if(currHref.substring(0, index).concat(htmlString) == address.substring(0, address.indexOf(api_level) + 9).concat(htmlString) && foundPage != 1 && isCurrentApi == 0) {
                var currLevel = currHref.substring(currHref.length - 1 - htmlString.length, currHref.length - htmlString.length);
                if(currLevel == '.') {
		  currLevel = currHref.substring(currHref.length - 2 - htmlString.length, currHref.length - htmlString.length - 1);
		}
                if(currLevel < newLevel) {
                  newLevel = currLevel;
                  newHref = domain.concat(currHref);
                  foundPage = 0;
                }
              }
            }
          });
          if(isLoad == 0 && foundPage == 0){
            if(newLevel > level) {
              alert("This page is available only from API level number ".concat(newLevel," Therefore, you are being redirected to that page in the ", newLevel, " level."));
            } else {
              alert("This page is deprecated in ".concat(level," level. It is available only until ", newLevel, " Therefore, you are being redirected to that page in the ", newLevel, " level."));
            }
            level = newLevel;
	    if(htmlString.length != 0) {
	      if(newHref.substring(newHref.length, newHref.length - 1) == '#') {
		newHref = newHref.substring(0, newHref.length - 1 - htmlString.length).concat(htmlString);
	      }
	      if(address == newHref.substring(newHref.indexOf(domain) + 7, newHref.length)) {
		$('#sidebar-first .active-trail a').each(function() { // run over all the book tree 
		    currHref = this.href.substring((this.href).indexOf(domain) + 7, (this.href).length);
		    index = currHref.indexOf(api_level) + 9;
		  if((index != 8 && (currHref.substring(index, index + 1) == level))) { // the current book link match to the current level  
		    $(this).addClass('current_api');
		  } else {
		    $(this).removeClass('current_api');
		  }
		});
	      }
	    }
            window.location = newHref;
          }
          $('.apiLevelSelector option').each(function(){
            if($(this).attr('title') == level) {
              $(this).attr("selected","selected");
            } else {
              $(this).removeAttr("selected");
            }
          });
          isLoad = 0;
        }
      }).change();
    }
  };
})(jQuery);;
/*
Copyright (c) 2003-2012, CKSource - Frederico Knabben. All rights reserved.
For licensing, see LICENSE.html or http://ckeditor.com/license
*/

/*
 WARNING: clear browser's cache after you modify this file.
 If you don't do this, you may notice that browser is ignoring all your changes.
 */
CKEDITOR.editorConfig = function(config) {
    config.indentClasses = [ 'rteindent1', 'rteindent2', 'rteindent3', 'rteindent4' ];

    // [ Left, Center, Right, Justified ]
    config.justifyClasses = [ 'rteleft', 'rtecenter', 'rteright', 'rtejustify' ];

    // The minimum editor width, in pixels, when resizing it with the resize handle.
    config.resize_minWidth = 450;

    // Protect PHP code tags (<?...?>) so CKEditor will not break them when
    // switching from Source to WYSIWYG.
    // Uncommenting this line doesn't mean the user will not be able to type PHP
    // code in the source. This kind of prevention must be done in the server
    // side
    // (as does Drupal), so just leave this line as is.
    config.protectedSource.push(/<\?[\s\S]*?\?>/g); // PHP Code
    config.protectedSource.push(/<code>[\s\S]*?<\/code>/gi); // Code tags
    config.extraPlugins = '';

    /*
    * Append here extra CSS rules that should be applied into the editing area.
    * Example:
    * config.extraCss = 'body {color:#FF0000;}';
    */
    config.extraCss = '';
    /**
    * Sample extraCss code for the "marinelli" theme.
    */
    if (Drupal.settings.ckeditor.theme == "marinelli") {
        config.extraCss += "body{background:#FFF;text-align:left;font-size:0.8em;}";
        config.extraCss += "#primary ol, #primary ul{margin:10px 0 10px 25px;}";
    }
    if (Drupal.settings.ckeditor.theme == "newsflash") {
        config.extraCss = "body{min-width:400px}";
    }

    /**
    * CKEditor's editing area body ID & class.
    * See http://drupal.ckeditor.com/tricks
    * This setting can be used if CKEditor does not work well with your theme by default.
    */
    config.bodyClass = '';
    config.bodyId = '';
    /**
    * Sample bodyClass and BodyId for the "marinelli" theme.
    */
    if (Drupal.settings.ckeditor.theme == "marinelli") {
        config.bodyClass = 'singlepage';
        config.bodyId = 'primary';
    }
}

/*
 * Sample toolbars
 */

//Toolbar definition for basic buttons
Drupal.settings.cke_toolbar_DrupalBasic = [ [ 'Format', 'Bold', 'Italic', '-', 'NumberedList','BulletedList', '-', 'Link', 'Unlink', 'Image' ] ];

//Toolbar definition for Advanced buttons
Drupal.settings.cke_toolbar_DrupalAdvanced = [
    ['Source'],
    ['Cut','Copy','Paste','PasteText','PasteFromWord','-','SpellChecker', 'Scayt'],
    ['Undo','Redo','Find','Replace','-','SelectAll','RemoveFormat'],
    ['Image','Flash','Table','HorizontalRule','Smiley','SpecialChar'],
    ['Maximize', 'ShowBlocks'],
    '/',
    ['Format'],
    ['Bold','Italic','Underline','Strike','-','Subscript','Superscript'],
    ['NumberedList','BulletedList','-','Outdent','Indent','Blockquote'],
    ['JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock','-','BidiRtl','BidiLtr'],
    ['Link','Unlink','Anchor','Linkit','LinkToNode','LinkToMenu'],
    ['DrupalBreak', 'DrupalPageBreak']
];

// Toolbar definiton for all buttons
Drupal.settings.cke_toolbar_DrupalFull = [
    ['Source'],
    ['Cut','Copy','Paste','PasteText','PasteFromWord','-','SpellChecker', 'Scayt'],
    ['Undo','Redo','Find','Replace','-','SelectAll','RemoveFormat'],
    ['Image','Flash','Table','HorizontalRule','Smiley','SpecialChar','Iframe'],
    '/',
    ['Bold','Italic','Underline','Strike','-','Subscript','Superscript'],
    ['NumberedList','BulletedList','-','Outdent','Indent','Blockquote','CreateDiv'],
    ['JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock','-','BidiRtl','BidiLtr'],
    ['Link','Unlink','Anchor','Linkit','LinkToNode', 'LinkToMenu'],
    '/',
    ['Format','Font','FontSize'],
    ['TextColor','BGColor'],
    ['Maximize', 'ShowBlocks'],
    ['DrupalBreak', 'DrupalPageBreak'],
    '/',
    ['Geshi-code','Geshi-php','Geshi-bash','Geshi-html','Geshi-css'],
];;
